package aud.exam.prep.tree;

abstract class OrderedBinaryTreeNodeProcessor<V> implements OrderedTreeProcessor<V, BinaryTreeNode<V>> {
    @Override
    public BinaryTreeNode<V> newEmptyTree() {
        return null;
    }

    @Override
    public Iterable<V> iterate(BinaryTreeNode<V> tree) {
        return () ->
                new BinaryTreeIterator<>(tree);
    }

    @Override
    public void print(BinaryTreeNode<V> tree) {
        printRec(tree, 0);
    }

    private void printRec(BinaryTreeNode<V> tree, int indent) {
        if (tree == null) {
            System.out.println("- *");
            return;
        }

        System.out.println("-> " + tree.key);

        System.out.print(" |".repeat(indent));
        System.out.print(" L");
        printRec(tree.left, indent + 1);

        System.out.print(" |".repeat(indent));
        System.out.print(" L");
        printRec(tree.right, indent + 1);
    }
}